library MySQL_PL_FPC;

{$mode objfpc}{$H+}

uses
  SysUtils,
  Classes,
  MySQL4,
  Strings;

{$R *.res}

Const
  Inputs   = 14;  // number of inputs
  Outputs  = 0;   // number of outputs


{INPUTS}
  SRV   = 0;   // Server IP
  DB    = 1;   // Database
  USR   = 2;   // User
  PWD   = 3;   // Password
  TBL   = 4;   // Table
  DTA1  = 5;   // Data In 1
  LIN1  = 6;   // Line In 1 Name
  DTA2  = 7;   // Data In 2
  LIN2  = 8;   // Line In 2 Name
  DTA3  = 9;   // Data In 3
  LIN3  = 10;  // Line In 3 Name
  DTA4  = 11;  // Data In 4
  LIN4  = 12;  // Line In 4 Name
  CLK   = 13;  // Clock Input


{OUTPUTS}

{USER}
  DLLIndex = 100;       // DLL No. set by ProfiLab
  CLK_old = 0;          // index user variable CLK_old

Type
  TDLLParams = array[0..100] of extended;   // Type of ProfiLab DLL parameters
  PDLLParams = ^TDLLParams;                 // Pointer to ProfiLab DLL parameters

  TStringParams = array[0..100] of PChar;   // Additional string parameters for CalculateEx
  PStringParams = ^TStringParams;           // Pointer to string parameters

Function NumInputs: Byte;
  begin
    result:=Inputs; //Define number of component input pins
  end;

Function NumOutputs: Byte;
  begin
    result:=Outputs; //Define number of component output pins
  end;

Function InputName(Channel: Byte): ShortString; // Return name for each component input pin
begin
   // string inputs must be named with leading '$' character
   case Channel of
   SRV       :  result:='$SRV';
   DB        :  result:='$DB';
   USR       :  result:='$USR';
   PWD       :  result:='$PWD';
   TBL       :  result:='$TBL';
   DTA1      :  result:='$DTA1';
   LIN1      :  result:='$LIN1';
   DTA2      :  result:='$DTA2';
   LIN2      :  result:='$LIN2';
   DTA3      :  result:='$DTA3';
   LIN3      :  result:='$LIN3';
   DTA4      :  result:='$DTA4';
   LIN4      :  result:='$LIN4';
   CLK       :  result:='CLK';
   end;
end;

Function OutputName(Channel: Byte): ShortString; // Return name for each component output pin
begin
      // string outputs must be named with leading '$' character!
end;

// New CalculateEx method now allows string parameters...
Procedure CalculateEx(PInput,POutput,PUser: PDLLParams; PStrings: PStringParams); //called regularly from ProfiLab

CONST
  pro1 = 'INSERT INTO %s (%s,%s,%s,%s) VALUES(%s,%s,%s,%s)';


VAR
  sock                       : PMYSQL;
  qmysql                     : TMYSQL;
  table                      : String;
  line1,line2,line3,line4    : String;
  data1,data2,data3,data4    : String;
  writedb                    : String;

begin

  if PInput^[CLK]<2.5 then //check CLK input LOW
    begin
      if (PInput^[CLK]<2.5) and not(PUser^[CLK_old]<2.5) then //check out falling edge at CLK input
        begin

        table:=strPas(PStrings^[TBL]);  //Read out Table Name
        line1:=strPas(PStrings^[LIN1]);  //Read out Line Names
        line2:=strPas(PStrings^[LIN2]);
        line3:=strPas(PStrings^[LIN3]);
        line4:=strPas(PStrings^[LIN4]);
        data1:=strPas(PStrings^[DTA1]);  //Read out Data
        data2:=strPas(PStrings^[DTA2]);
        data3:=strPas(PStrings^[DTA3]);
        data4:=strPas(PStrings^[DTA4]);

        writedb:=Format(pro1, [table,line1,line2,line3,line4,data1,data2,data3,data4]);  //Define Send string

        mysql_init(PMySQL(@qmysql));                             //Database Init
        sock :=  mysql_real_connect(PMysql(@qmysql),PStrings^[SRV],PStrings^[USR],PStrings^[PWD],nil,0,nil,0); //Sock definition
        mysql_select_db(sock,PStrings^[DB]); //Selec Database from Sock
        mysql_query(sock,PChar(writedb));    //Send string to sock
        mysql_close(sock);                   //Close Sock link

        end;
    end;
    PUser^[CLK_old]:=PInput^[CLK]; //Remember CLK status for next call
end;

//export methods for ProfiLab
exports NumInputs,
        NumOutputs,
        CalculateEx,
        InputName,
        OutputName;

begin
end.

